
/*  gBackGround changes your root window background.
    Copyright (C) 1999  Govind Salinas

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef GBACKGROUND_H
  #include "gBackGround.h"
#endif

void button1_callback(GtkWidget *widget, gpointer data)
{
  gint length, rnum;
  GList *cur;

  length = g_list_length(filelist);
  if (!length) return;
  else rnum = (rand())%length;
  cur =  g_list_nth(filelist, rnum);
  curfile = lastfile = g_strdup((gchar *)cur->data);
  if (!draw_background(curfile)) button1_callback(NULL, NULL);
}

void button2_callback(GtkWidget *widget, gpointer data)
{
  GtkWidget *button, *box;

  if (window) return;
  window = gnome_dialog_new("Choose Your Background.", GNOME_STOCK_BUTTON_OK,
                             GNOME_STOCK_BUTTON_CANCEL, NULL);
  gtk_container_set_border_width(GTK_CONTAINER(window), 5);
  gnome_dialog_button_connect((GnomeDialog *)window, 1, dialog_cancel, NULL);
  gnome_dialog_button_connect((GnomeDialog *)window, 0, dialog_ok, NULL);
  gtk_signal_connect(GTK_OBJECT(window), "delete_event",
                     GTK_SIGNAL_FUNC(dialog_cancel), NULL);
  gtk_signal_connect(GTK_OBJECT(window), "destroy",
                     GTK_SIGNAL_FUNC(dialog_cancel), NULL);
  combo = gtk_combo_new();
  gtk_combo_set_popdown_strings(GTK_COMBO(combo), dirnames);
  gtk_combo_set_case_sensitive(GTK_COMBO(combo), TRUE);
  gtk_combo_set_use_arrows_always(GTK_COMBO(combo), TRUE);
  gtk_combo_set_value_in_list(GTK_COMBO(combo), TRUE, FALSE);
  gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(combo)->entry), FALSE);
  gtk_signal_connect(GTK_OBJECT(GTK_COMBO(combo)->entry), "changed",
                     GTK_SIGNAL_FUNC(combo_callback), NULL);
  gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(window)->vbox), combo, FALSE, FALSE,
                     0);
  pbar = gtk_progress_bar_new();
  gtk_progress_bar_set_bar_style(GTK_PROGRESS_BAR(pbar),
                                 GTK_PROGRESS_CONTINUOUS);
  gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(window)->vbox), pbar, FALSE,
                     TRUE, 0);
  frame = gtk_frame_new(NULL);
  gtk_container_set_border_width(GTK_CONTAINER(frame), 3);
  gtk_widget_set_usize(frame, 285, 360);
  gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(window)->vbox), frame, FALSE,
                     TRUE, 0);
  box = gtk_hbox_new(FALSE, 5);
  gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(window)->vbox), box, TRUE, TRUE, 0);
  button = gtk_button_new_with_label("Add and Remove Items.");
  gtk_box_pack_start(GTK_BOX(box), button, TRUE, FALSE, 5);
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
                     GTK_SIGNAL_FUNC(add_items), NULL);
  gtk_widget_show_all(window);
  displayfiles(g_list_nth_data(dirnames, 0));
}

void dialog_ok(GtkWidget *widget, gpointer data)
{
  gtk_signal_disconnect_by_func(GTK_OBJECT(window), dialog_cancel, NULL);
  gnome_dialog_close((GnomeDialog *)window);
  scrollwindow = window = NULL;
  lastfile = curfile;
  changemode = 0;
  if (filesel) kill_sel(NULL, NULL);
}

void dialog_cancel(GtkWidget *widget, gpointer data)
{
  gtk_signal_disconnect_by_func(GTK_OBJECT(window), dialog_cancel, NULL);
  gnome_dialog_close((GnomeDialog *)window);
  scrollwindow = window = NULL;
  curfile = lastfile;
  draw_background(lastfile);
  if (filesel) kill_sel(NULL, NULL);
}

void combo_callback(GtkWidget *widget, gpointer data)
{
  gint x, l;
  gchar *string;

  l = g_list_length(dirnames);
  string = gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(combo)->entry));
  for (x = 0; x < l; x++)
    if (!strcmp((gchar *)g_list_nth_data(dirnames, x), string)) {
      displayfiles(g_list_nth_data(dirnames, x));
      return;
    }
}

gint changebgrandom(gpointer data)
{
  if (changemode != 1) return FALSE;
  button1_callback(NULL, NULL);
  return TRUE;
}

gint changebglinear(gpointer data)
{
  static int pos = 0;
  int length;
  GList *cur;

  if (changemode != 2) return FALSE;
  length = g_list_length(filelist);
  if (!length) return TRUE;
  pos = pos%length;
  cur = g_list_nth(filelist, pos);
  curfile = lastfile = strdup((gchar *)cur->data);
  draw_background((gchar *)cur->data);
  pos++;
  return TRUE;
}

void choosebg(GtkWidget *widget, gpointer data)
{
  curfile = strdup((gchar *)data);
  draw_background(curfile);
}

void about_callback(AppletWidget *widget, gpointer data)
{
  GtkWidget *about;
  static const gchar *authors[] = {"Govind Salinas", NULL};

  about = gnome_about_new( _("gBackGround applet"), _("0.8"),
                           _("Copyright (C)1999 Govind Salinas"), authors,
                           _("Change your background all day long!!!\n\n"
                             "The top button will give you a random picture "
                             "from a specified list.  The bottom one will let "
                             "you choose from thubnails of that list and let "
                             "you change the list.  You can start and stop "
                             "automatic changes of your background and set "
                             "the mode of display (tiled/scaled/centered) with "
                             "the drop down menu.\n \nI hope you enjoy your "
                             "applet.\n \n \n \nWant and applet or application "
                             "but can't find one already written.  Develop "
                             "your own.  Go to http://developer.gnome.org and "
                             "code \'till your fingers fall off. :)"), NULL);
  gtk_widget_show(about);
}

void menu_item_callback(AppletWidget *widget, gpointer data)
{
  switch ((gint)data) {
    case 0:
           changemode = 0;
           break;
    case 1:
           changemode = 2;
           gtk_timeout_add(interval, (GtkFunction)changebglinear, NULL);
           changebglinear(NULL);
           break;
    case 2:
           changemode = 1;
           gtk_timeout_add(interval, (GtkFunction)changebgrandom, NULL);
           changebgrandom(NULL);
    case 3:
           tile = 1;
           scaleit = center = 0;
           draw_background(curfile);
           break;
    case 4:
           tile = 0;
           scaleit = 1;
           center = 0;
           draw_background(curfile);
           break;
    case 5:
           tile = 0;
           scaleit = 0;
           center = 1;
           draw_background(curfile);
           break;
    default:
           return;
  }
  return;
}

void change_orient(GtkWidget *widget, PanelOrientType o, gpointer data)
{
  if (o == ORIENT_UP || o == ORIENT_DOWN) {
    gtk_widget_hide(hbox);
    gtk_widget_show(vbox);
  }
  if (o == ORIENT_LEFT || o == ORIENT_RIGHT) {
    gtk_widget_hide(vbox);
    gtk_widget_show(hbox);
  }
}
