
/*  gBackGround changes your root window background.
    Copyright (C) 1999  Govind Salinas

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef GBACKGROUND_H
  #include "gBackGround.h"
#endif

GtkWidget *prop = NULL;
gint tiled1, scaled1, centered1, mimetype1;
gint interval1, startmethod1;
gint changemethod1;

void apply_prop(GnomePropertyBox *box, gint pagenum, gpointer data)
{
  GList *cur;

  tile = tiled1;
  scaleit = scaled1;
  center = centered1;
  startmode = startmethod1;
  changemode = changemethod1;
  interval = interval1;
  userealmime = mimetype1;
  save_config();
  (g_list_first(dirnames))->data = NULL;
  gnome_uri_list_free_strings(dirnames);
  gnome_uri_list_free_strings(filelist);
  g_list_free(indfiles);
  for (cur = g_list_first(dirlist); cur != NULL; cur = g_list_next(cur))
    g_list_free(cur->data);
  g_list_free(dirlist);
  dirlist = indfiles = dirnames = filelist = NULL;
  init();
}

void spinner_changed(GtkWidget *widget, gpointer data)
{
  if (GTK_NOTEBOOK(GNOME_PROPERTY_BOX(prop)->notebook)->cur_page)
     gnome_property_box_changed(GNOME_PROPERTY_BOX(prop));
  interval1 = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(widget)) * 1000;
}

void start_group(GtkWidget *widget, gpointer data)
{
  if (GTK_NOTEBOOK(GNOME_PROPERTY_BOX(prop)->notebook)->cur_page)
     gnome_property_box_changed(GNOME_PROPERTY_BOX(prop));
  startmethod1 = (gint)data;
}

void display_group(GtkWidget *widget, gpointer data)
{
  if (GTK_NOTEBOOK(GNOME_PROPERTY_BOX(prop)->notebook)->cur_page)
     gnome_property_box_changed(GNOME_PROPERTY_BOX(prop));
  switch ((gint)data) {
    case 0:
          tiled1 = 1; scaled1 = 0; centered1 = 0;
          break;
    case 1:
          tiled1 = 0; scaled1 = 0; centered1 = 1;
          break;
    case 2:
          tiled1 = 0; scaled1 = 1; centered1 = 0;
          break;
  }
}

void change_group(GtkWidget *widget, gpointer data)
{
  if (GTK_NOTEBOOK(GNOME_PROPERTY_BOX(prop)->notebook)->cur_page)
     gnome_property_box_changed(GNOME_PROPERTY_BOX(prop));
  changemethod1 = (gint)data;
}

void mime_button(GtkWidget *widget, gpointer data)
{
  if (GTK_NOTEBOOK(GNOME_PROPERTY_BOX(prop)->notebook)->cur_page)
     gnome_property_box_changed(GNOME_PROPERTY_BOX(prop));
  mimetype1 = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget));
}

void properties_callback(AppletWidget *widget, gpointer data)
{
  GtkWidget *frame1, *frame2, *box1, *box2, *box3;
  GtkWidget *button, *spinner, *label, *box4;
  GtkObject *adj;
  GSList *group;

  tiled1 = tile;
  scaled1 = scaleit;
  centered1 = center;
  startmethod1 = startmode;
  changemethod1 = changemode;
  interval1 = interval;
  mimetype1 = userealmime;

  prop = gnome_property_box_new();
  gtk_signal_connect(GTK_OBJECT(prop), "apply", GTK_SIGNAL_FUNC(apply_prop),
                     NULL);
  gtk_signal_connect(GTK_OBJECT(prop), "apply", GTK_SIGNAL_FUNC(apply_prop),
                     NULL);
  gtk_signal_connect(GTK_OBJECT(prop), "apply", GTK_SIGNAL_FUNC(apply_prop),
                     NULL);
  frame1 = gtk_frame_new("Properties.");
  box1 = gtk_vbox_new(FALSE, 5);
  gtk_container_add(GTK_CONTAINER(frame1), box1);
  box2 = gtk_hbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(box1), box2, TRUE, TRUE, 5);
  button = gtk_button_new_with_label("Add and Remove Items.");
  gtk_box_pack_start(GTK_BOX(box2), button, TRUE, FALSE, 5);
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
                     GTK_SIGNAL_FUNC(add_items), NULL);
  box3 = gtk_vbox_new(FALSE, 2);
  gtk_box_pack_start(GTK_BOX(box2), box3, FALSE, FALSE, 5);
  label = gtk_label_new("How often (seconds) do you want your background "
                       "changed?");
  gtk_box_pack_start(GTK_BOX(box3), label, TRUE, TRUE, 2);
  box4 = gtk_hbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(box3), box4, FALSE, FALSE, 0);
  adj = gtk_adjustment_new(interval/1000, 5, RAND_MAX/1000, 1, 30, 0);
  spinner = gtk_spin_button_new(GTK_ADJUSTMENT(adj), 1, 0);
  gtk_signal_connect(GTK_OBJECT(spinner), "changed",
                     GTK_SIGNAL_FUNC(spinner_changed), NULL);
  gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(spinner), FALSE);
  gtk_widget_set_usize(spinner, 100, 20);
  gtk_box_pack_end(GTK_BOX(box4), spinner, FALSE, FALSE, 2);
  box2 = gtk_vbox_new(FALSE, 0);
  frame2 = gtk_frame_new("Start up with?");
  gtk_container_add(GTK_CONTAINER(frame2), box2);
  gtk_box_pack_start(GTK_BOX(box1), frame2, TRUE, TRUE, 5);

  button = gtk_radio_button_new_with_label(NULL, "Do not change background on "
                                                 "startup.");
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
                     GTK_SIGNAL_FUNC(start_group), (gpointer)0);
  group = gtk_radio_button_group(GTK_RADIO_BUTTON(button));
  if (!startmode)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), TRUE);
  gtk_box_pack_start(GTK_BOX(box2), button, TRUE, TRUE, 5);
  button = gtk_radio_button_new_with_label(gtk_radio_button_group(
                                           GTK_RADIO_BUTTON(button)),
                                           "Change to a random background on "
                                           "startup.");
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
                     GTK_SIGNAL_FUNC(start_group), (gpointer)1);
  if (startmode == 1)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), TRUE);
  gtk_box_pack_start(GTK_BOX(box2), button, TRUE, TRUE, 5);
  button = gtk_radio_button_new_with_label(gtk_radio_button_group(
                                           GTK_RADIO_BUTTON(button)),
                                           "Change to last background on "
                                           "startup.");
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
                     GTK_SIGNAL_FUNC(start_group), (gpointer)2);
  if (startmode == 2)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), TRUE);
  gtk_box_pack_start(GTK_BOX(box2), button, TRUE, TRUE, 5);
  box3 = gtk_hbox_new(FALSE, 5);
  gtk_box_pack_start(GTK_BOX(box1), box3, TRUE, TRUE, 0);
  frame2 = gtk_frame_new("Display your backgrounds?");
  gtk_box_pack_start(GTK_BOX(box3), frame2, TRUE, TRUE, 0);
  box2 = gtk_vbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(frame2), box2);

  button = gtk_radio_button_new_with_label(NULL, "Tiled.");
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
                     GTK_SIGNAL_FUNC(display_group), (gpointer)0);
  group = gtk_radio_button_group(GTK_RADIO_BUTTON(button));
  if (tile)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), TRUE);
  gtk_box_pack_start(GTK_BOX(box2), button, TRUE, TRUE, 5);
  button = gtk_radio_button_new_with_label(gtk_radio_button_group(
                                           GTK_RADIO_BUTTON(button)),
                                           "Centered");
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
                     GTK_SIGNAL_FUNC(display_group), (gpointer)1);
  if (center)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), TRUE);
  gtk_box_pack_start(GTK_BOX(box2), button, TRUE, TRUE, 5);
  button = gtk_radio_button_new_with_label(gtk_radio_button_group(
                                           GTK_RADIO_BUTTON(button)),
                                           "Scaled");
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
                     GTK_SIGNAL_FUNC(display_group), (gpointer)2);
  if (scaleit)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), TRUE);
  gtk_box_pack_start(GTK_BOX(box2), button, TRUE, TRUE, 5);

  frame2 = gtk_frame_new("Automatically change your background?");
  gtk_box_pack_start(GTK_BOX(box3), frame2, TRUE, TRUE, 0);
  box2 = gtk_vbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(frame2), box2);

  button = gtk_radio_button_new_with_label(NULL, "Don't automatically "
                                                 "change my background.");
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
                     GTK_SIGNAL_FUNC(change_group), (gpointer)0);
  group = gtk_radio_button_group(GTK_RADIO_BUTTON(button));
  if (!changemode)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), TRUE);
  gtk_box_pack_start(GTK_BOX(box2), button, TRUE, TRUE, 5);
  button = gtk_radio_button_new_with_label(gtk_radio_button_group(
                                           GTK_RADIO_BUTTON(button)),
                                           "Change to a random background.");
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
                     GTK_SIGNAL_FUNC(change_group), (gpointer)1);
  if (changemode == 1)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), TRUE);
  gtk_box_pack_start(GTK_BOX(box2), button, TRUE, TRUE, 5);
  button = gtk_radio_button_new_with_label(gtk_radio_button_group(
                                           GTK_RADIO_BUTTON(button)),
                                           "Go through the list of "
                                           "backgrounds in order.");
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
                     GTK_SIGNAL_FUNC(change_group), (gpointer)2);
  if (changemode == 2)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), TRUE);
  gtk_box_pack_start(GTK_BOX(box2), button, TRUE, TRUE, 5);
  frame2 = gtk_frame_new("Mime method?");
  gtk_box_pack_start(GTK_BOX(box1), frame2, TRUE, TRUE, 5);
  button = gtk_check_button_new_with_label("Use more accurate real mime "
                                           "instead of quicker psuedo mime.");
  if (userealmime)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), TRUE);
  gtk_signal_connect(GTK_OBJECT(button), "toggled",
                     GTK_SIGNAL_FUNC(mime_button), NULL);
  gtk_container_add(GTK_CONTAINER(frame2), button);
  gnome_property_box_append_page(GNOME_PROPERTY_BOX(prop), frame1,
                                 gtk_label_new("Settings."));
  gtk_widget_show_all(prop);
}
